diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/libraw/libraw_version.h libkdcraw/libkdcraw/libraw/libraw/libraw_version.h
--- libkdcraw-wrk/libkdcraw/libraw/libraw/libraw_version.h	2022-11-07 08:15:53.614821808 +0300
+++ libkdcraw/libkdcraw/libraw/libraw/libraw_version.h	2022-11-07 07:46:31.730795008 +0300
@@ -1,47 +1,63 @@
-/*
+/* -*- C++ -*-
  * File: libraw_version.h
- * Copyright 2008-2009 Alex Tutubalin <lexa@lexa.ru>
- * Created: Mon Sept  8, 2008 
+ * Copyright 2008-2020 LibRaw LLC (info@libraw.org)
+ * Created: Mon Sept  8, 2008
  *
  * LibRaw C++ interface
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
- * 02110-1301, USA.
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+(See the file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+(See the file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
  */
 
 #ifndef __VERSION_H
 #define __VERSION_H
 
-#define LIBRAW_MAJOR_VERSION  0
-#define LIBRAW_MINOR_VERSION  7
-#define LIBRAW_PATCH_VERSION  2
-#define LIBRAW_VERSION_TAIL   Release
+#define LIBRAW_MAJOR_VERSION 0
+#define LIBRAW_MINOR_VERSION 20
+#define LIBRAW_PATCH_VERSION 2
+#define LIBRAW_VERSION_TAIL Release
+
+#define LIBRAW_SHLIB_CURRENT 20
+#define LIBRAW_SHLIB_REVISION 0
+#define LIBRAW_SHLIB_AGE 0
+
+#define _LIBRAW_VERSION_MAKE(a, b, c, d) #a "." #b "." #c "-" #d
+#define LIBRAW_VERSION_MAKE(a, b, c, d) _LIBRAW_VERSION_MAKE(a, b, c, d)
+
+#define LIBRAW_VERSION_STR                                                     \
+  LIBRAW_VERSION_MAKE(LIBRAW_MAJOR_VERSION, LIBRAW_MINOR_VERSION,              \
+                      LIBRAW_PATCH_VERSION, LIBRAW_VERSION_TAIL)
+
+#define LIBRAW_MAKE_VERSION(major, minor, patch)                               \
+  (((major) << 16) | ((minor) << 8) | (patch))
 
-#define _LIBRAW_VERSION_MAKE(a,b,c,d) #a"."#b"."#c"-"#d
-#define LIBRAW_VERSION_MAKE(a,b,c,d) _LIBRAW_VERSION_MAKE(a,b,c,d)
+#define LIBRAW_VERSION                                                         \
+  LIBRAW_MAKE_VERSION(LIBRAW_MAJOR_VERSION, LIBRAW_MINOR_VERSION,              \
+                      LIBRAW_PATCH_VERSION)
 
-#define LIBRAW_VERSION_STR LIBRAW_VERSION_MAKE(LIBRAW_MAJOR_VERSION,LIBRAW_MINOR_VERSION,LIBRAW_PATCH_VERSION,LIBRAW_VERSION_TAIL)
+#define LIBRAW_CHECK_VERSION(major, minor, patch)                              \
+  (LibRaw::versionNumber() >= LIBRAW_MAKE_VERSION(major, minor, patch))
 
-#define LIBRAW_MAKE_VERSION(major,minor,patch) \
-    (((major) << 16) | ((minor) << 8) | (patch))
+#define LIBRAW_RUNTIME_CHECK_VERSION_EXACT()                                   \
+  ((LibRaw::versionNumber() & 0xffff00) ==                                     \
+   LIBRAW_MAKE_VERSION(LIBRAW_MAJOR_VERSION, LIBRAW_MINOR_VERSION, 0))
 
-#define LIBRAW_VERSION \
-    LIBRAW_MAKE_VERSION(LIBRAW_MAJOR_VERSION,LIBRAW_MINOR_VERSION,LIBRAW_PATCH_VERSION)
+#define LIBRAW_RUNTIME_CHECK_VERSION_NOTLESS()                                 \
+  ((LibRaw::versionNumber() & 0xffff00) >=                                     \
+   LIBRAW_MAKE_VERSION(LIBRAW_MAJOR_VERSION, LIBRAW_MINOR_VERSION, 0))
 
-#define LIBRAW_CHECK_VERSION(major,minor,patch) \
-    ( LibRaw::versionNumber() >= LIBRAW_MAKE_VERSION(major,minor,patch) )
+#define LIBRAW_COMPILE_CHECK_VERSION(major, minor)                             \
+  (LIBRAW_MAKE_VERSION(major, minor, 0) == (LIBRAW_VERSION & 0xffff00))
 
+#define LIBRAW_COMPILE_CHECK_VERSION_NOTLESS(major, minor)                     \
+  (LIBRAW_MAKE_VERSION(major, minor, 0) <= (LIBRAW_VERSION & 0xffff00))
 
 #endif
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/samples/4channels.cpp libkdcraw/libkdcraw/libraw/samples/4channels.cpp
--- libkdcraw-wrk/libkdcraw/libraw/samples/4channels.cpp	2022-11-07 08:15:53.614821808 +0300
+++ libkdcraw/libkdcraw/libraw/samples/4channels.cpp	2022-11-07 07:46:31.730795008 +0300
@@ -1,65 +1,59 @@
-/*
+/* -*- C++ -*-
  * File: 4channels.cpp
- * Copyright 2009 Alex Tutubalin <lexa@lexa.ru>
+ * Copyright 2008-2020 LibRaw LLC (info@libraw.org)
  * Created: Mon Feb 09, 2009
  *
  * LibRaw sample
  * Generates 4 TIFF file from RAW data, one file per channel
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
- * 02110-1301, USA.
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+
  */
 #include <stdio.h>
 #include <string.h>
 #include <math.h>
-#ifndef WIN32
+#include "libraw/libraw.h"
+
+#ifndef LIBRAW_WIN32_CALLS
 #include <netinet/in.h>
 #else
 #include <winsock2.h>
 #endif
 
-#include "libraw/libraw.h"
-
-#ifdef WIN32
+#ifdef LIBRAW_WIN32_CALLS
 #define snprintf _snprintf
 #endif
 
 int main(int ac, char *av[])
 {
-    int  i, ret;
-    int autoscale=0,filtering_mode=LIBRAW_FILTERING_DEFAULT,black_subtraction=1;
-    char outfn[1024],thumbfn[1024]; 
-
-    LibRaw RawProcessor;
-    if(ac<2) 
-        {
-          usage:
-            printf(
-                "4channeld - LibRaw %s sample. %d cameras supported\n"
-                "Usage: %s [-s N] [-g] [-A] [-B] [-N] raw-files....\n"
-                "\t-s N - select Nth image in file (default=0)\n"
-                "\t-g - use gamma correction with gamma 2.2 (not precise,use for visual inspection only)\n"
-                "\t-A - autoscaling (by integer factor)\n"
-                "\t-B - no black subtraction\n"
-                "\t-N - no raw curve\n"
-                ,LibRaw::version(),
-                LibRaw::cameraCount(),
-                av[0]);
-            return 0;
-        }
-    
+  int i, ret;
+  int autoscale = 0, black_subtraction = 1, use_gamma = 0;
+  char outfn[1024];
+
+  LibRaw RawProcessor;
+  if (ac < 2)
+  {
+  usage:
+    printf("4channels - LibRaw %s sample. %d cameras supported\n"
+           "Usage: %s [-s N] [-g] [-A] [-B] [-N] raw-files....\n"
+           "\t-s N - select Nth image in file (default=0)\n"
+           "\t-g - use gamma correction with gamma 2.2 (not precise,use for "
+           "visual inspection only)\n"
+           "\t-A - autoscaling (by integer factor)\n"
+           "\t-B - no black subtraction\n",
+           LibRaw::version(), LibRaw::cameraCount(), av[0]);
+    return 0;
+  }
+
 #define P1 RawProcessor.imgdata.idata
 #define S RawProcessor.imgdata.sizes
 #define C RawProcessor.imgdata.color
@@ -67,121 +61,113 @@
 #define P2 RawProcessor.imgdata.other
 #define OUT RawProcessor.imgdata.params
 
-    OUT.document_mode=2;
-    OUT.output_bps=16;
-    OUT.output_tiff=1;
-    OUT.user_flip=0;
-    OUT.no_auto_bright = 1;
-    OUT.half_size=1;
-    OUT.filtering_mode= LIBRAW_FILTERING_AUTOMATIC;
-
-    for (i=1;i<ac;i++)
-        {
-            if(av[i][0]=='-')
-                {
-                    if(av[i][1]=='s' && av[i][2]==0)
-                        {
-                            i++;
-                            OUT.shot_select=atoi(av[i]);
-                        }
-                    else if(av[i][1]=='g' && av[i][2]==0)
-                        OUT.gamma_16bit=1;
-                    else if(av[i][1]=='A' && av[i][2]==0)
-                        autoscale=1;
-                    else if(av[i][1]=='B' && av[i][2]==0)
-                        {
-                            filtering_mode |= (LIBRAW_FILTERING_NOZEROES | LIBRAW_FILTERING_NOBLACKS);
-                            black_subtraction=0;
-                        }
-                    else if(av[i][1]=='N' && av[i][2]==0)
-                        filtering_mode |= LIBRAW_FILTERING_NORAWCURVE;
-                    else
-                        goto usage;
-                    continue;
-                }
-            if(filtering_mode)
-                OUT.filtering_mode = (LibRaw_filtering) filtering_mode;
-            int r,c;
-            printf("Processing file %s\n",av[i]);
-            if( (ret = RawProcessor.open_file(av[i])) != LIBRAW_SUCCESS)
-                {
-                    fprintf(stderr,"Cannot open %s: %s\n",av[i],libraw_strerror(ret));
-                    continue; // no recycle b/c open file will recycle itself
-                }
-            if(P1.is_foveon)
-                {
-                    printf("Cannot process foveon image %s\n",av[i]);
-                    continue ;
-                }
-            if( (ret = RawProcessor.unpack() ) != LIBRAW_SUCCESS)
-                {
-                    fprintf(stderr,"Cannot unpack %s: %s\n",av[i],libraw_strerror(ret));
-                    continue;
-                }
-            if(black_subtraction && C.black>0)
-                {
-                    for(int j=0; j<S.iheight*S.iwidth; j++)
-                        for(int c = 0; c< 4; c++)
-                            if(RawProcessor.imgdata.image[j][c]>C.black)
-                                RawProcessor.imgdata.image[j][c]-=C.black;
-                            else
-                                RawProcessor.imgdata.image[j][c]=0;
-                }
-
-            if(autoscale)
-                {
-                    unsigned max=0,scale;
-                    for(int j=0; j<S.iheight*S.iwidth; j++)
-                        for(int c = 0; c< 4; c++)
-                            if(max < RawProcessor.imgdata.image[j][c])
-                                max = RawProcessor.imgdata.image[j][c]; 
-                    if (max >0 && max< 1<<15)
-                        {
-                            scale = (1<<16)/max;
-                            printf("Scaling with multiplier=%d (max=%d)\n",scale,max);
-                            for(int j=0; j<S.iheight*S.iwidth; j++)
-                                for(c=0;c<4;c++)
-                                    RawProcessor.imgdata.image[j][c] *= scale;
-                        }
-		   printf("Black level (scaled)=%d\n",C.black*scale);
-                }
-		else
-		   printf("Black level (unscaled)=%d\n",C.black);
-
-
-            // hack to make dcraw tiff writer happy
-	    int isrgb=(P1.colors==4?0:1);
-            P1.colors = 1;
-            S.width = S.iwidth;
-            S.height = S.iheight;
-
-            for (int layer=0;layer<4;layer++)
-                {
-                    if(layer>0)
-                        {
-                            for (int rc = 0; rc < S.iheight*S.iwidth; rc++)
-                                RawProcessor.imgdata.image[rc][0] = RawProcessor.imgdata.image[rc][layer];
-                        }
-		    char lname[8];
-		    if(isrgb)
-		      {
-			snprintf(lname,7,"%c",(char*)("RGBG")[layer]);
-			if(layer==3)
-			  strcat(lname,"2");
-		      }
-		    else
-		      snprintf(lname,7,"%c",(char*)("GCMY")[layer]);
-
-                    if(OUT.shot_select)
-                        snprintf(outfn,sizeof(outfn),"%s-%d.%s.tiff",av[i],OUT.shot_select,lname);
-                    else
-                        snprintf(outfn,sizeof(outfn),"%s.%s.tiff",av[i],lname);
-                    
-                    printf("Writing file %s\n",outfn);
-                    if( LIBRAW_SUCCESS != (ret = RawProcessor.dcraw_ppm_tiff_writer(outfn)))
-                        fprintf(stderr,"Cannot write %s: %s\n",outfn,libraw_strerror(ret));
-                }
-
-        }
-    return 0;
+  OUT.output_bps = 16;
+  OUT.output_tiff = 1;
+  OUT.user_flip = 0;
+  OUT.no_auto_bright = 1;
+  OUT.half_size = 1;
+
+  for (i = 1; i < ac; i++)
+  {
+    if (av[i][0] == '-')
+    {
+      if (av[i][1] == 's' && av[i][2] == 0)
+      {
+        i++;
+        OUT.shot_select = av[i] ? atoi(av[i]) : 0;
+      }
+      else if (av[i][1] == 'g' && av[i][2] == 0)
+        use_gamma = 1;
+      else if (av[i][1] == 'A' && av[i][2] == 0)
+        autoscale = 1;
+      else if (av[i][1] == 'B' && av[i][2] == 0)
+      {
+        black_subtraction = 0;
+      }
+      else
+        goto usage;
+      continue;
+    }
+    if (!use_gamma)
+      OUT.gamm[0] = OUT.gamm[1] = 1;
+
+    int c;
+    printf("Processing file %s\n", av[i]);
+    if ((ret = RawProcessor.open_file(av[i])) != LIBRAW_SUCCESS)
+    {
+      fprintf(stderr, "Cannot open %s: %s\n", av[i], libraw_strerror(ret));
+      continue; // no recycle b/c open file will recycle itself
+    }
+    if (P1.is_foveon)
+    {
+      printf("Cannot process Foveon image %s\n", av[i]);
+      continue;
+    }
+    if ((ret = RawProcessor.unpack()) != LIBRAW_SUCCESS)
+    {
+      fprintf(stderr, "Cannot unpack %s: %s\n", av[i], libraw_strerror(ret));
+      continue;
+    }
+    RawProcessor.raw2image();
+    if (black_subtraction)
+    {
+      RawProcessor.subtract_black();
+    }
+
+    if (autoscale)
+    {
+      unsigned max = 0, scale = 1;
+      for (int j = 0; j < S.iheight * S.iwidth; j++)
+        for (int c = 0; c < 4; c++)
+          if (max < RawProcessor.imgdata.image[j][c])
+            max = RawProcessor.imgdata.image[j][c];
+      if (max > 0 && max < 1 << 15)
+      {
+        scale = (1 << 16) / max;
+        printf("Scaling with multiplier=%d (max=%d)\n", scale, max);
+        for (int j = 0; j < S.iheight * S.iwidth; j++)
+          for (c = 0; c < 4; c++)
+            RawProcessor.imgdata.image[j][c] *= scale;
+      }
+      printf("Black level (scaled)=%d\n", C.black * scale);
+    }
+    else
+      printf("Black level (unscaled)=%d\n", C.black);
+
+    // hack to make dcraw tiff writer happy
+    int isrgb = (P1.colors == 4 ? 0 : 1);
+    P1.colors = 1;
+    S.width = S.iwidth;
+    S.height = S.iheight;
+
+    for (int layer = 0; layer < 4; layer++)
+    {
+      if (layer > 0)
+      {
+        for (int rc = 0; rc < S.iheight * S.iwidth; rc++)
+          RawProcessor.imgdata.image[rc][0] =
+              RawProcessor.imgdata.image[rc][layer];
+      }
+      char lname[8];
+      if (isrgb)
+      {
+        snprintf(lname, 7, "%c", ((char *)("RGBG"))[layer]);
+        if (layer == 3)
+          strcat(lname, "2");
+      }
+      else
+        snprintf(lname, 7, "%c", ((char *)("GCMY"))[layer]);
+
+      if (OUT.shot_select)
+        snprintf(outfn, sizeof(outfn), "%s-%d.%s.tiff", av[i], OUT.shot_select,
+                 lname);
+      else
+        snprintf(outfn, sizeof(outfn), "%s.%s.tiff", av[i], lname);
+
+      printf("Writing file %s\n", outfn);
+      if (LIBRAW_SUCCESS != (ret = RawProcessor.dcraw_ppm_tiff_writer(outfn)))
+        fprintf(stderr, "Cannot write %s: %s\n", outfn, libraw_strerror(ret));
+    }
+  }
+  return 0;
 }
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/samples/Makefile libkdcraw/libkdcraw/libraw/samples/Makefile
--- libkdcraw-wrk/libkdcraw/libraw/samples/Makefile	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/samples/Makefile	2022-11-07 07:46:31.642795007 +0300
@@ -0,0 +1,2 @@
+all:
+	(cd ..; make all_samples)
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/samples/README-samples.rus libkdcraw/libkdcraw/libraw/samples/README-samples.rus
--- libkdcraw-wrk/libkdcraw/libraw/samples/README-samples.rus	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/samples/README-samples.rus	2022-11-07 07:46:31.642795007 +0300
@@ -0,0 +1,2 @@
+
+See ../doc/Samples-LibRaw-rus.html and ../doc/Samples-LibRaw-eng.html
